//
//  PhotoAlbumTool.h
//  PhotoAlbumDemo
//
//  Created by 栗子 on 2018/7/27.
//  Copyright © 2018年 http://www.cnblogs.com/Lrx-lizi/.     https://github.com/lrxlizi/     https://blog.csdn.net/qq_33608748. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Photos/PHPhotoLibrary.h>


@interface PhotoAlbumTool : NSObject

/*
 判断相册是否授权
 */
+(void)authorizationStatusIsSuccess:(void(^)(void))success jumpSet:(void(^)(void))set;


/**
 是否可以使用相机
 */
+(BOOL)isCanUsePhotos;

/**
 提示框
 */

+(UIAlertController *)UIAlertControllerStyle:(UIAlertControllerStyle)style  title:(NSString *)titleStr message:(NSString *)messageStr  actionsStyle:(UIAlertActionStyle)actionsStyle  actionTextArr:(NSArray *)array otherActionStyle:(UIAlertActionStyle)otherStyle otherText:(NSString *)text actionsHandler:(void (^)(UIAlertAction * actions,NSString *text))handler  otherHandler:(void (^)(UIAlertAction * other))otherHandler viewController:(UIViewController *)vc;

+ (void)addTipsWithErrorMessage:(NSString *)errorMessage andTarget:(UINavigationController *)nav;

/*
 创建相册
 */
+(void)createAssetCollectionName:(NSString *)name;

/**
 取出相册中名字为albumTitle的相薄
*/
 +(PHAssetCollection *)fetchAssetColletion:(NSString *)albumTitle;

/**
 遍历百某个相薄中的所有图片reultArr中是image
 */
+ (void)enumerateAssetsInAssetCollection:(PHAssetCollection *)assetCollection original:(BOOL)original reult:(void(^)(NSMutableArray *array))reultArr;

/**
 删除相薄中的某张图片
 */
+ (void)deleteAssetCollection:(PHAsset *)asset deleteSuccess:(void(^)(void))delSuccess deleteFailed:(void(^)(void))failed;

/*
 删除删除assetCollection相册中的第几张图相册中的第几张图
 */
+ (void)deletePicIndex:(NSInteger)index inAssetCollection:(PHAssetCollection *)assetCollection deleteSuccess:(void(^)(void))delSuccess deleteFailed:(void(^)(void))failed;

/**
 通过asset 显示照片
 */
+ (void)fetchImageWithAsset:(PHAsset*)mAsset imageBlock:(void(^)(NSData *data))imageBlock;

/**
 保存图片到相册
 */
+(void)addAssetCollectionImage:(UIImage *)image assetCollection:(PHAssetCollection *)collection addSuccess:(void(^)(void))addSuccess addFailed:(void(^)(void))failed;

/**
 根据image得到asset
 */
+ (void)getAssetWithImage:(UIImage *)image getAssetSuccess:(void(^)(PHAsset *asset))getSuccess;







@end
