//
//  PhotoAlbumTool.m
//  PhotoAlbumDemo
//
//  Created by 栗子 on 2018/7/27.
//  Copyright © 2018年 http://www.cnblogs.com/Lrx-lizi/.     https://github.com/lrxlizi/     https://blog.csdn.net/qq_33608748. All rights reserved.
//

#import "PhotoAlbumTool.h"

@implementation PhotoAlbumTool


+(void)authorizationStatusIsSuccess:(void(^)(void))success jumpSet:(void(^)(void))set{
    
    PHAuthorizationStatus status = [PHPhotoLibrary authorizationStatus];
    // 1.判断用户的授权状态
    if (status == PHAuthorizationStatusNotDetermined) {
        // 如果状态是不确定的话,block中的内容会等到授权完成再调用

        [PHPhotoLibrary requestAuthorization:^(PHAuthorizationStatus status) {
            if (status == PHAuthorizationStatusAuthorized) {
            }
            success();
        }];
    } else if (status == PHAuthorizationStatusAuthorized) {
        
       success();
        
        
    } else {
        // 使用第三方框架,弹出一个页面提示用户去打开授权 进入设置界面->找到当前应用->打开允许访问相册开关
        set();
    }
}
+(BOOL)isCanUsePhotos {
    
        AVAuthorizationStatus status = [AVCaptureDevice authorizationStatusForMediaType:AVMediaTypeVideo];
        if (status == AVAuthorizationStatusRestricted || status == AVAuthorizationStatusDenied) {
            //无权限
            return NO;
        
    }
    return YES;
}
/**
 提示框
 */

+(UIAlertController *)UIAlertControllerStyle:(UIAlertControllerStyle)style  title:(NSString *)titleStr message:(NSString *)messageStr  actionsStyle:(UIAlertActionStyle)actionsStyle  actionTextArr:(NSArray *)array otherActionStyle:(UIAlertActionStyle)otherStyle otherText:(NSString *)text actionsHandler:(void (^)(UIAlertAction * actions,NSString *text))handler  otherHandler:(void (^)(UIAlertAction * other))otherHandler viewController:(UIViewController *)vc{
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:titleStr message:messageStr preferredStyle:style];
    [alertController addAction:[UIAlertAction actionWithTitle:text style:otherStyle handler:^(UIAlertAction * _Nonnull action) {
        otherHandler(action);
    }]];
    for (NSInteger i=0; i<array.count; i++) {
        NSString *titleStr = [NSString stringWithFormat:@"%@",array[i]];
        [alertController addAction:[UIAlertAction actionWithTitle:titleStr style:actionsStyle handler:^(UIAlertAction * _Nonnull action) {
            handler(action,titleStr);
        }]];
    }
    [vc presentViewController:alertController animated:YES completion:nil];
    return alertController;
}

+ (void)addTipsWithErrorMessage:(NSString *)errorMessage andTarget:(UINavigationController *)nav
{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:nil message:errorMessage preferredStyle:UIAlertControllerStyleAlert];
    [nav presentViewController:alertController animated:YES completion:nil];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [nav dismissViewControllerAnimated:YES completion:nil];
    });
}

/*
 创建相册
 */
+(void)createAssetCollectionName:(NSString *)name{
    
    [[PHPhotoLibrary sharedPhotoLibrary] performChanges:^{
        // 调用判断是否已有该名称相册
        PHAssetCollection *assetCollection = [self fetchAssetColletion:name];
        
        //创建一个操作图库的对象
        PHAssetCollectionChangeRequest *assetCollectionChangeRequest;
        if (assetCollection) {
            // 已有相册
            assetCollectionChangeRequest = [PHAssetCollectionChangeRequest changeRequestForAssetCollection:assetCollection];
        } else {
            // 1.创建自定义相册
            assetCollectionChangeRequest = [PHAssetCollectionChangeRequest creationRequestForAssetCollectionWithTitle:name];
        }
    }completionHandler:^(BOOL success, NSError * _Nullable error) {
        
        //提醒用户是否保存成功
        if (error) {
            NSLog(@"相册创建失败");
            
        } else {
            NSLog(@"相册创建成功");
            
        }
    }];
}

/**
 取出相册中名字为albumTitle的相薄
 */
+(PHAssetCollection *)fetchAssetColletion:(NSString *)albumTitle

{
    // 获取所有的相册
    PHFetchResult *result = [PHAssetCollection  fetchAssetCollectionsWithType:PHAssetCollectionTypeAlbum subtype:PHAssetCollectionSubtypeAlbumRegular options:nil];
    //遍历相册数组,是否已创建该相册
    for (PHAssetCollection *assetCollection in result) {
        
        if ([assetCollection.localizedTitle isEqualToString:albumTitle]) {
            
            return assetCollection;
            
        }
    }
    return nil;
}

/**
 遍历百某个相薄中的所有图片 reultArr中是image
 */
+ (void)enumerateAssetsInAssetCollection:(PHAssetCollection *)assetCollection original:(BOOL)original reult:(void(^)(NSMutableArray *array))reultArr
{
    NSMutableArray *picImageArr = [NSMutableArray array];
    PHImageRequestOptions *options = [[PHImageRequestOptions alloc] init];
    // 同步获得图片, 只会返回1张图片
    options.synchronous = YES;
    // 获得某个相簿中的所有PHAsset对象
    PHFetchResult<PHAsset *> *assets = [PHAsset fetchAssetsInAssetCollection:assetCollection options:nil];
    for (PHAsset *asset in assets) {
        
        [[PHImageManager defaultManager] requestImageDataForAsset:asset options:nil resultHandler:^(NSData * _Nullable imageData, NSString * _Nullable dataUTI, UIImageOrientation orientation, NSDictionary * _Nullable info) {
            NSData  * data = [NSData dataWithData:imageData];
            [picImageArr addObject:[UIImage imageWithData:data]];
            
        }];
        
    }
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        reultArr(picImageArr);//不加延迟 拿不到图片
    });
    
}
/**
 删除相薄中的某张图片
 */
+ (void)deleteAssetCollection:(PHAsset *)asset deleteSuccess:(void(^)(void))delSuccess deleteFailed:(void(^)(void))failed{
    
   
    [[PHPhotoLibrary sharedPhotoLibrary]performChanges:^{
        
        [PHAssetChangeRequest deleteAssets:@[asset]];
        
    } completionHandler:^(BOOL success, NSError * _Nullable error) {
        if (success) {
            delSuccess();
            NSLog(@"删除成功");
        }else{
            failed();
            NSLog(@"删除失败");
        }
    }];
}
/*
 删除assetCollection相册中的第几张图
 */
+ (void)deletePicIndex:(NSInteger)index inAssetCollection:(PHAssetCollection *)assetCollection deleteSuccess:(void(^)(void))delSuccess deleteFailed:(void(^)(void))failed{
    PHFetchResult<PHAsset *> *assets = [PHAsset fetchAssetsInAssetCollection:assetCollection options:nil];
    PHAsset *asset = assets[index];
    [[PHPhotoLibrary sharedPhotoLibrary]performChanges:^{
        
        [PHAssetChangeRequest deleteAssets:@[asset]];
        
    } completionHandler:^(BOOL success, NSError * _Nullable error) {
        if (success) {
            delSuccess();
            NSLog(@"删除成功");
        }else{
            failed();
            NSLog(@"删除失败");
        }
    }];
}

/**
 通过asset 显示照片
*/
 + (void)fetchImageWithAsset:(PHAsset*)mAsset imageBlock:(void(^)(NSData *data))imageBlock {
    [[PHImageManager defaultManager] requestImageDataForAsset:mAsset options:nil resultHandler:^(NSData * _Nullable imageData, NSString * _Nullable dataUTI, UIImageOrientation orientation, NSDictionary * _Nullable info) {
        // 直接得到最终的 NSData 数据
        if (imageBlock) {
            imageBlock(imageData);
        }
    }];
}
/**
 保存图片到相册
 */
+(void)addAssetCollectionImage:(UIImage *)image assetCollection:(PHAssetCollection *)collection addSuccess:(void(^)(void))addSuccess addFailed:(void(^)(void))failed{
    // 保存相片的标识
    __block NSString *assetId = nil;
    
    [[PHPhotoLibrary sharedPhotoLibrary] performChanges:^{
        // 保存相片到相机胶卷，并返回标识
        assetId = [PHAssetCreationRequest creationRequestForAssetFromImage:image].placeholderForCreatedAsset.localIdentifier;
    } completionHandler:^(BOOL success, NSError * _Nullable error) {
        if (!success) {
            NSLog(@"保存失败：%@", error);
            return;
        }
        
        // 根据标识获得相片对象
        PHAsset *asset = [PHAsset fetchAssetsWithLocalIdentifiers:@[assetId] options:nil].lastObject;
        if (collection == nil) return;
        // 保存相片到自定义相册中
        [[PHPhotoLibrary sharedPhotoLibrary] performChanges:^{
            [[PHAssetCollectionChangeRequest changeRequestForAssetCollection:collection] addAssets:@[asset]];
      
        } completionHandler:^(BOOL success, NSError * _Nullable error) {
            if (success) {
                NSLog(@"保存成功");
                addSuccess();
            } else {
                failed();
                NSLog(@"保存失败：%@", error);
            }
        }];
    }];
}

/**
 根据image得到asset
 */
+ (void)getAssetWithImage:(UIImage *)image getAssetSuccess:(void(^)(PHAsset *asset))getSuccess{
    __block NSString *assetId = nil;
    
    [[PHPhotoLibrary sharedPhotoLibrary] performChanges:^{
        // 保存相片到相机胶卷，并返回标识
        assetId = [PHAssetCreationRequest creationRequestForAssetFromImage:image].placeholderForCreatedAsset.localIdentifier;
    } completionHandler:^(BOOL success, NSError * _Nullable error) {
        if (!success) {
            NSLog(@"保存失败：%@", error);
            return;
        }
        
        // 根据标识获得相片对象
        PHAsset *asset = [PHAsset fetchAssetsWithLocalIdentifiers:@[assetId] options:nil].lastObject;
        getSuccess(asset);
    }];
   
}

@end
