//
//  ViewController.m
//  PhotoAlbumDemo
//
//  Created by 栗子 on 2018/7/27.
//  Copyright © 2018年 http://www.cnblogs.com/Lrx-lizi/.     https://github.com/lrxlizi/     https://blog.csdn.net/qq_33608748. All rights reserved.
//

/*
 
 自定义相册
 相册支持添加/删除图片
 根据image获取asset
 遍历相册中的图片
 
 */


#import "ViewController.h"
#import "PictureDisplayViewController.h"

@interface ViewController ()<UINavigationControllerDelegate,UIImagePickerControllerDelegate>

@property(nonatomic,strong)UIImageView *showImageView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
 
    self.view.backgroundColor = [UIColor whiteColor];
    
    UIButton *btn = [[UIButton alloc]initWithFrame:CGRectMake(100, 100, 100, 100)];
    btn.backgroundColor = [UIColor redColor];
    [self.view addSubview:btn];
    [btn setTitle:@"拍照相册" forState:(UIControlStateNormal)];
    [btn addTarget:self action:@selector(btnClicekd) forControlEvents:UIControlEventTouchUpInside];
    
    [PhotoAlbumTool authorizationStatusIsSuccess:^{
        
    } jumpSet:^{
        
    }];
    
    [PhotoAlbumTool isCanUsePhotos];
    
    self.showImageView = [[UIImageView alloc]initWithFrame:CGRectMake(100, 250, 200, 200)];
    [self.view addSubview:self.showImageView];
    self.showImageView.backgroundColor = [UIColor cyanColor];

    
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc]initWithTitle:@"相册图片展示" style:(UIBarButtonItemStylePlain) target:self action:@selector(action)];
    
}
- (void)action{
    
    PictureDisplayViewController *pic = [PictureDisplayViewController new];

    [PhotoAlbumTool enumerateAssetsInAssetCollection:[PhotoAlbumTool fetchAssetColletion:ALNUM] original:YES reult:^(NSMutableArray *array) {
        [ pic.dataSource removeAllObjects];
        pic.dataSource = array;
    }];
    [self.navigationController pushViewController:pic animated:YES];
    
}
- (void)btnClicekd{
    
    [PhotoAlbumTool UIAlertControllerStyle:(UIAlertControllerStyleActionSheet) title:nil message:nil actionsStyle:(UIAlertActionStyleDefault) actionTextArr:@[@"相机",@"相册"] otherActionStyle:(UIAlertActionStyleCancel) otherText:@"取消" actionsHandler:^(UIAlertAction *actions, NSString *text) {
        NSLog(@"点击了%@",text);
        if ([text isEqualToString:@"相机"]) {
            [self pushImagePickerController];
        }else if ([text isEqualToString:@"相册"]){
             [self takePhoto];
        }
        
    } otherHandler:^(UIAlertAction *other) {
        NSLog(@"点击了取消");
    } viewController:self];
    
}

#pragma mark 从相册里选择
-(void)takePhoto{
    if (![UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary]) { // 没有相册
        return;
    }
    UIImagePickerController *pickerVC = [[UIImagePickerController alloc] init];
    pickerVC.delegate = self;
    pickerVC.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    [self presentViewController:pickerVC animated:YES completion:nil];
    
}
//拍照
-(void)pushImagePickerController{
    UIImagePickerControllerSourceType sourceType = UIImagePickerControllerSourceTypeCamera;
    if ([UIImagePickerController isSourceTypeAvailable: UIImagePickerControllerSourceTypeCamera])
    {
        UIImagePickerController *picker = [[UIImagePickerController alloc] init];
        picker.delegate = self;
        picker.allowsEditing = YES;
        picker.sourceType = sourceType;
        [self presentViewController:picker animated:YES completion:nil];
    }else
    {
        [PhotoAlbumTool addTipsWithErrorMessage:@"模拟器中无法打开照相机,请在真机中使用" andTarget:self.navigationController];
        NSLog(@"模拟器中无法打开照相机,请在真机中使用");
    }
}
#pragma mark - UIImagePickerControllerDelegate

- (void)imagePickerController:(nonnull UIImagePickerController *)picker didFinishPickingMediaWithInfo:(nonnull NSDictionary<NSString *,id> *)info
{
    NSString *type = [info objectForKey:UIImagePickerControllerMediaType];
    if ([type isEqualToString:@"public.image"])
    {
        UIImage* image = [info objectForKey:@"UIImagePickerControllerOriginalImage"];
        //保存图片
        [self savePhoto:image];
        
        //关闭相册界面
        [picker dismissViewControllerAnimated:YES completion:nil];
        
    }
}
//点击相册或者拍照页面的 取消按钮
- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
    [picker dismissViewControllerAnimated:YES completion:nil];
}


//保存图片
- (void)savePhoto:(UIImage *)img{
    
    [PhotoAlbumTool addAssetCollectionImage:img assetCollection:[PhotoAlbumTool fetchAssetColletion:ALNUM] addSuccess:^{
        dispatch_async(dispatch_get_main_queue(), ^{
            self.showImageView.image = img;

        });
        
    } addFailed:^{
        
    }];
    
}
@end
