//
//  PictureDisplayViewController.m
//  PhotoAlbumDemo
//
//  Created by 栗子 on 2018/7/27.
//  Copyright © 2018年 http://www.cnblogs.com/Lrx-lizi/.     https://github.com/lrxlizi/     https://blog.csdn.net/qq_33608748. All rights reserved.
//

#import "PictureDisplayViewController.h"
#import "PictureDisplayCell.h"

@interface PictureDisplayViewController ()<UICollectionViewDelegate,UICollectionViewDataSource,UIAlertViewDelegate>

@property(nonatomic,strong)UICollectionView *collectionVIew;
@property (nonatomic, assign) NSInteger index;

@end

@implementation PictureDisplayViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    
    UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc]init];
    layout.itemSize =CGSizeMake((self.view.frame.size.width-30)/2, 180);
    layout.minimumLineSpacing = 10;
    layout.minimumInteritemSpacing = 10;
    self.collectionVIew = [[UICollectionView alloc]initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height) collectionViewLayout:layout];
    self.collectionVIew.dataSource = self;
    self.collectionVIew.delegate = self;
    self.collectionVIew.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:self.collectionVIew];
    [self.collectionVIew registerNib:[UINib nibWithNibName:@"PictureDisplayCell" bundle:nil] forCellWithReuseIdentifier:@"IDENTIFER"];
    
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    return self.dataSource.count;
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    
    PictureDisplayCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"IDENTIFER" forIndexPath:indexPath];
    cell.backgroundColor = [UIColor redColor];
    cell.displayIV.image = self.dataSource[indexPath.row];
    return cell;
    
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{
    self.index = indexPath.row;

    [PhotoAlbumTool getAssetWithImage:self.dataSource[self.index] getAssetSuccess:^(PHAsset *asset) {
        NSLog(@"%@",asset);
        
        [PhotoAlbumTool deletePicIndex:indexPath.row inAssetCollection:[PhotoAlbumTool fetchAssetColletion:ALNUM] deleteSuccess:^{
            NSLog(@"-----删除成功");
            dispatch_async(dispatch_get_main_queue(), ^{
                [self.dataSource removeObjectAtIndex:self.index];
                [self.collectionVIew reloadData];
            });
        } deleteFailed:^{
            
        }];
 
    }];
}

-(UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout insetForSectionAtIndex:(NSInteger)section {
   
        return UIEdgeInsetsMake(0, 10, 0, 10);;//分别为上、左、下、右
   
}


- (void)setDataSource:(NSMutableArray *)dataSource{
    _dataSource = dataSource;
    [self.collectionVIew reloadData];
    
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}



@end
